
### DETERMINISTIC SIMULATION

# Euler method
#
euler <- function (t = 100, dt = 0.001, fun = autoreg, ic=c(1,10,10,1,1)) 
{
        p <- length(ic) 
        n <- t/dt #// number of time points
        xmat <- matrix(0,ncol=p,nrow=n)
        x <- ic
        xmat[1,] <- x
        for (i in 2:n) {
                x <- x + fun(x) * dt
                xmat[i,] <- x
        }
       xmat
}

autoreg<-function(x, k1=1, k2=0.1, k3=1, k4=0.1, k5=0.01, k6=0.05)
{
        c(k3*x[5] - k1*x[1]*x[2] + k2*x[4]- k5*x[1],
          k2*x[4] - k1*x[1]*x[2],
          k4*x[2] - k6*x[3],
          k1*x[1]*x[2] - k2*x[4],
          0)

}

results <- euler()
#p<-par(mfrow=c(3,1))
#plot.ts(results[,1], xlab="Time", ylab="Concentration", main="Deterministic, Euler: P1")
#plot.ts(results[,4], xlab="Time", ylab="Concentration", main="P1.G2")
plot.ts(results[,2], xlab="Time", ylab="Concentration", main="G2")
#plot.ts(results[,5], xlab="Time", ylab="Concentration", main="G1")
#plot.ts(results[,3], xlab="Time", ylab="Concentration", main="P2")